(function() {
    if (window.___adb2 == null) {
        window.___adb2 = new Date().getTime();

        var hideElementsStrong = {
            strongSelectors: null,
            getStandardTags: function() {
                return "<a><abbr><acronym><address><applet><area><article><aside><audio><b><base><basefont><bdi>"
                       + "<bdo><big><blockquote><body><br><button><canvas><caption><center><cite><code><col><colgroup>"
                       + "<command><datalist><dd><del><details><dfn><dialog><dir><div><dl><dt><em><embed><fieldset>"
                       + "<figcaption><figure><font><footer><form><frame><frameset><head><header><hgroup><h1><h2>"
                       + "<h3><h4><h5><h6><hr><i><iframe><img><input><ins><kbd><keygen><label><legend><li><link>"
                       + "<main><map><mark><menu><meta><meter><nav><noframes><noscript><object><ol><optgroup>"
                       + "<option><output><p><param><pre><html><picture><progress><q><rp><rt><ruby><s><samp>"
                       + "<script><section><select><small><source><span><strike><strong><style><sub><summary>"
                       + "<sup><table><tbody><td><textarea><template><tfoot><th><thead><time><title><tr>"
                       + "<track><tt><u><ul><var><video><wbr><svg><path><rect><ellipse><line><circle>"
                       + "<polygon><polyline><text><element><filter><feGaussianBlur><feOffset><linearGradient>"
                       + "<radialGradient><stop><defs><x-video>";
            },
            getElementCSS: function(curEle, attr) {
                if (curEle.currentstyle != null) {
                    return curEle.currentstyle[attr];
                }
                var s = document.defaultView.getComputedStyle(curEle, null);
                if (s != null) {
                    return s[attr];
                }
                return null;
            },
            isNeedHideBlockElement: function(s) {
                if (!s) {
                    return false;
                }

                if (s.id && (typeof s.id === 'string') && (s.id.indexOf('x_ele_') >= 0 || s.id.indexOf('xbt_') >= 0)) {
                    return false;
                }

                if (s.getAttribute != null) {
                    var attr = s.getAttribute('x-ele');
                    if (attr != null) {
                        return false;
                    }
                }

                if (hideElementsStrong.strongSelectors == null) {
                    hideElementsStrong.strongSelectors = XWebViewApi.getElementHidingSelectors(XWebViewApi.ADBLOCK_OPTION_HIDING_SELECTORS_STRONG); //[[{}, {}], [{}, {}]]
                    console.log('parsed hiding strong selectors: ' + hideElementsStrong.strongSelectors.length);
                }

                var tags = hideElementsStrong.getStandardTags();
                for (let item of hideElementsStrong.strongSelectors) {
                    var selectors = XWebViewApi.parse(item, []);
                    for (let selector of selectors) {
                        var ret = false;
                        var retLog = '';

                        if (selector.tag != null && selector.tag.length > 0) {
                            if (s.tagName == null || s.tagName.length <= 0) {
                                ret = false;
                            } else if (selector.tag === '!standard') {
                                ret = tags.indexOf(s.tagName.toLowerCase()) < 0;
                            } else {
                                selector.tagRegex = selector.tagRegex || new RegExp(selector.tag);
                                ret = selector.tagRegex.test(s.tagName.toLowerCase());
                            }

                            if (ret) {
                                retLog = 'hide block ele by tag:' + s.tagName + '@' + selector.tag;
                            }
                        }

                        if (selector.id != null && selector.id.length > 0) {
                            if (s.id == null || s.id.length <= 0) {
                                ret = false;
                            } else {
                                selector.idRegex = selector.idRegex || new RegExp(selector.id);
                                ret = selector.idRegex.test(s.id);
                            }

                            if (ret) {
                                retLog = 'hide block ele by id:' + s.id + '@' + selector.id;
                            }
                        }

                        if (selector.class != null && selector.class.length > 0) {
                            if (s.className == null || s.className.length <= 0) {
                                ret = false;
                            } else {
                                selector.classRegex = selector.classRegex || new RegExp(selector.class);
                                ret = selector.classRegex.test(s.className);
                            }

                            if (ret) {
                                retLog = 'hide block ele by class:' + s.className + '@' + selector.class;
                            }
                        }

                        if (selector.style != null && selector.style.length > 0) {
                            if (s.style == null || s.style.length <= 0) {
                                ret = false;
                            } else {
                                var styles = '';
                                for (var i = 0; i < s.style.length; ++i) {
                                    var prop = s.style[i];
                                    if (s.style[prop] != null && s.style[prop].length > 0) {
                                        styles = styles + prop + ':' + s.style[prop] + ';';
                                    }
                                }

                                if (styles.length <= 0) {
                                    ret = false;
                                } else {
                                    selector.styleRegex = selector.styleRegex || new RegExp(selector.style);
                                    ret = selector.styleRegex.test(styles);
                                }
                            }

                            if (ret) {
                                retLog = 'hide block ele by styles:' + styles + '@' + selector.style;
                            }
                        }

                        if (selector.css != null && selector.css.length > 0) {
                            var css = hideElementsStrong.getElementCSS(s, 'background');
                            if (css == null || css.length <= 0) {
                                ret = false;
                            } else {
                                selector.cssRegex = selector.cssRegex || new RegExp(selector.css);
                                ret = selector.cssRegex.test(css);
                            }

                            if (ret) {
                                retLog = 'hide block ele by css:' + css + '@' + selector.css;
                            }
                        }

                        if (selector.innerHTML != null && selector.innerHTML.length > 0) {
                            var innerHTML = s.innerHTML;
                            if (innerHTML == null || innerHTML.length <= 0) {
                                ret = false;
                            } else {
                                selector.innerHTMLRegex = selector.innerHTMLRegex || new RegExp(selector.innerHTML);
                                ret = selector.innerHTMLRegex.test(innerHTML);
                            }

                            if (ret) {
                                retLog = 'hide block ele by innerHTML:' + innerHTML + '@' + selector.innerHTML;
                            }
                        }

                        if (ret) {
                            if (XWebViewApi.debugMode()) {
                                console.log(retLog);
                            }
                            return true;
                        }
                    }
                }

                return false;
            },
            getElementInfo: function(e) {
                var styles = '';
                for (var i = 0; e.style != null && i < e.style.length; ++i) {
                    var prop = e.style[i];
                    if (e.style[prop] != null && e.style[prop].length > 0) {
                        styles = styles + prop + ':' + e.style[prop] + ';';
                    }
                }
                return "node:" + e.tagName + ", id:" + e.id + ", class:" + e.className + ", style:" + styles;
            },
            hideElement: function(e, debug) {
                if (debug) {
                    console.log("hideElement " + hideElementsStrong.getElementInfo(e));
                }
                if (e.parentNode) {
                    e.parentNode.removeChild(e);
                } else {
                    e.style.display = 'none !important';
                    e.style.height = "0 !important"
                    e.style.overflow = 'hidden !important'
                }
            },
            hideBlockElement: function(e, disableCheck) {
                var debug = false;
                if (!disableCheck && hideElementsStrong.isNeedHideBlockElement(e)) {
                    hideElementsStrong.hideElement(e, debug);
                } else {
                    if (e && e.childElementCount > 0) {
                        var removed = [];
                        for (let node of e.children) {
                            if (hideElementsStrong.isNeedHideBlockElement(node)) {
                                removed.push(node);
                            } else if (node.childElementCount > 0) {
                                hideElementsStrong.hideBlockElement(node, true);
                            }
                        }

                        if (removed.length > 0) {
                            for (let node of removed) {
                                hideElementsStrong.hideElement(node, debug);
                            }

                            if (e.childElementCount <= 0) {
                                hideElementsStrong.hideElement(e, debug);
                            }
                        }
                    }
                }
            },
            checkDyAds: function() {
                /*var d = document.querySelectorAll('div[style*="background:#000;opacity:0.01;"]');
                if (d != null && d.length > 1) {
                    hideElementsStrong.strongSelectors.push('[{"tag":"!standard"}]');

                    //height: 133.44px; margin-bottom: 0px; margin-left: 0px;
                    d = document.querySelectorAll('div[style*="height:"]');
                    if (d != null && d.length > 1) {
                        for (i = 0; i < d.length; ++i) {
                            if (d[i].id == d[i].className) {
                                hideElementsStrong.hideElement(d[i].parentNode);
                                break;
                            }
                        }
                    }
                    return true;
                }*/
                return false;
            }
        };

        function hideElementsByStyleSheets(hiddenFlag) {
            if (document[hiddenFlag] === true) {
                console.log('already hidden, exiting');
                return;
            }
            document[hiddenFlag] = true; // set flag not to do it again
            console.log("Not yet hidden! starting injecting css rules")

            var selectors = XWebViewApi.getElementHidingStyleSheets();
            console.log('parsed hiding style sheets: ' + selectors.length);

            var head = document.getElementsByTagName("head")[0];
            for (var i = 0; i < selectors.length; i++) {
                var txt = selectors[i].replace(/{display: none !important;}/g, '{display: none !important; height: 0 !important; overflow: hidden !important;}')
                var style = document.createElement("style");
                style.id = 'x_browser_hide_style_' + i;
                head.appendChild(style);
                style.textContent = txt;
            }

            console.log('finished injecting css rules');
        };

        function hideElementsByStrongRule(hiddenFlag) {
            if (document[hiddenFlag] === true) {
                console.log('already hidden, exiting');
                return;
            }
            document[hiddenFlag] = true; // set flag not to do it again
            console.log("Not yet hidden! starting monit")

            var hasDyAds = false;
            new MutationObserver(function(mutationsList) {
                //console.log("body changed:" + mutationsList.length);
                for (let mutation of mutationsList) {
                    if (mutation.type === 'childList') {
                        //console.log('A child node has been added or removed.');
                        if (!hasDyAds && hideElementsStrong.checkDyAds()) {
                            hasDyAds = true;
                            hideElementsStrong.hideBlockElement(document);
                        } else if (mutation.addedNodes != null) {
                            for (let node of mutation.addedNodes) {
                                if (hideElementsStrong.isNeedHideBlockElement(node)) {
                                    //console.log('A child node has been added and remove it who not in normal tag list:' + node.tagName);
                                    hideElementsStrong.hideElement(node);
                                } else {
                                    hideElementsStrong.hideBlockElement(node);
                                }
                                XWebViewApi.invokeCommand('elementchange', node);
                            }
                        }
                    } else if (mutation.type === 'attributes') {
                        console.log('The ' + mutation.attributeName + ' attribute was modified.');
                    }
                }
            }).observe(document, {subtree: true, childList: true});

            hideElementsStrong.hideBlockElement(document);
            console.log('finished monit');
        };

        function hideElements() {
            var meta = document.querySelector('meta[name=xl-app-page]');
            if (meta == null) {
                hideElementsByStyleSheets('x-code-css:' + window.___adb2);
                hideElementsByStrongRule('x-code-strong:' + window.___adb2);
            } else {
                console.log('xl app page');
            }
        }

//        const originalCreateElement = document.createElement;
//        document.createElement = function(tagName) {
//            console.log(new Error().stack);
//            return originalCreateElement.apply(this, arguments);
//        };
//
//        const originalAppendChild = Node.prototype.appendChild;
//        Node.prototype.appendChild = function(child) {
//            console.log(new Error().stack);
//            return originalAppendChild.apply(this, arguments);
//        };

        window.addEventListener('load', hideElements, true);
        document.addEventListener('DOMContentLoaded', hideElements, true);
        hideElements();
    }
})();